declare namespace m = "mynmspace";
declare function m:split-list($e as element()) as element()  {
    let $tokens := tokenize($e, "\s+")
    let $count := count($tokens)
    let $Na := xs:integer($count div 3)
    
    return element {'UVW'}{
      for $i in 0 to $Na - 1
        let $sub := fn:subsequence($tokens, 1+3*$i, 3)
        return element {'l'} {$sub}
      }
};

declare function m:process-list($e as element()) as element() {
  let $uvw := $e/*
  let $Na := count($uvw)
  return element {'UVW'}{
  for $i in 1 to $Na,
       $j in 1 to $Na
     
     let $ui := fn:subsequence(tokenize($uvw[$i], "\s+"), 1, 1)
     let $vi := fn:subsequence(tokenize($uvw[$i], "\s+"), 2, 1)
     let $wi := fn:subsequence(tokenize($uvw[$i], "\s+"), 3, 1)
     let $uj := fn:subsequence(tokenize($uvw[$j], "\s+"), 1, 1)
     let $vj := fn:subsequence(tokenize($uvw[$j], "\s+"), 2, 1)
     let $wj := fn:subsequence(tokenize($uvw[$j], "\s+"), 3, 1)
     return
       if ($i >= $j) then ()
       else
       (:
         element {'l'}{$uj,'-',$ui,',',$vj,'-',$vi,',',$wj,'-',$wi}
 :)
 
         element {'l'}{xs:double($uj) - xs:double($ui),
                           xs:double($vj) - xs:double($vi),
                           xs:double($wj) - xs:double($wi)}
     }
                  
};
  
document{
  let $e := m:split-list(doc('testList.xml')/testList/uvw)
  return m:process-list($e)
}
